Bug 1900497 - freecad fails to build with Python 3.10: error: aggregate 'QPainterPath textPath' has incomplete type and cannot be defined
Summary: freecad fails to build with Python 3.10: error: aggregate 'QPainterPath textP...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: freecad
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Richard Shaw
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-23 08:20 UTC by Tomáš Hrnčiar
Modified: 2021-05-14 21:11 UTC (History)
5 users (show)

Fixed In Version: freecad-0.19.2-1.fc34 freecad-0.19.2-1.fc33
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-05-10 01:05:38 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-23 08:20:19 UTC
freecad fails to build with Python 3.10.0a2.

/Gui/OpenGLImageBox.cpp:906:18: error: aggregate 'QPainterPath textPath' has incomplete type and cannot be defined
  906 |     QPainterPath textPath;
      |                  ^~~~~~~~

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01782619-freecad/

For all our attempts to build freecad with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/freecad/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Richard Shaw 2020-11-25 01:58:28 UTC
I have updated to 0.19 prerelease in Rawhide, Please test it and let me know if it works.

Comment 2 Miro Hrončok 2020-11-25 09:02:51 UTC
The copr build has:

Error: 
 Problem: package python3-pyside2-devel-1:5.15.1-2.fc34.x86_64 requires libpyside2.cpython-310-x86_64-linux-gnu.so.5.15()(64bit), but none of the providers can be installed
  - package python3-pyside2-1:5.15.1-1.fc34.x86_64 requires libQt5Core.so.5(Qt_5.15.1_PRIVATE_API)(64bit), but none of the providers can be installed
  - package python3-pyside2-1:5.15.1-2.fc34.x86_64 requires libQt5Core.so.5(Qt_5.15.1_PRIVATE_API)(64bit), but none of the providers can be installed
  - cannot install both qt5-qtbase-5.15.1-7.fc34.x86_64 and qt5-qtbase-5.15.2-2.fc34.x86_64
  - package qt5-qtbase-devel-5.15.2-2.fc34.x86_64 requires libQt5DBus.so.5(Qt_5.15.2_PRIVATE_API)(64bit), but none of the providers can be installed
  - package qt5-qtbase-devel-5.15.2-2.fc34.x86_64 requires qt5-qtbase(x86-64) = 5.15.2-2.fc34, but none of the providers can be installed
  - cannot install the best candidate for the job

We are rebuilding pyside2 again to see if it helps: https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-pyside2/

Comment 3 Richard Shaw 2020-11-25 13:27:06 UTC
Bah... Even with regular reminders when a new Qt gets built (which has been pretty frequent lately) PySide2 is always forgotten. I'm working on an update to 5.15.2 but ran into an issue and waiting on a response from upstream.

I'm also working on building a 0.19 pre-release build of FreeCAD (Rawhide already done). As 0.18.4 is over a year old this may help with some of the Qt quirks.

Comment 4 Miro Hrončok 2020-11-25 13:29:20 UTC
Actually, in Fedora, this was fine. But in our copr, we have picked this commit: https://src.fedoraproject.org/rpms/python-pyside2/c/820bfddaef7f1c4b9055112b7163467566c1acb3?branch=master whcih was built in the f34-kde tag and built it with old Qt. After rebuilding it once again, freecad build runs:

 https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/freecad/

Comment 5 Ben Cotton 2021-02-09 15:27:00 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 6 Fedora Update System 2021-05-05 21:29:20 UTC
FEDORA-2021-e69bf4bd76 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-e69bf4bd76

Comment 7 Fedora Update System 2021-05-05 21:29:25 UTC
FEDORA-2021-7639ce16f6 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-7639ce16f6

Comment 8 Fedora Update System 2021-05-06 01:34:12 UTC
FEDORA-2021-7639ce16f6 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-7639ce16f6`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-7639ce16f6

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Fedora Update System 2021-05-06 01:58:32 UTC
FEDORA-2021-e69bf4bd76 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-e69bf4bd76`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-e69bf4bd76

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-05-10 01:05:38 UTC
FEDORA-2021-e69bf4bd76 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 11 Fedora Update System 2021-05-14 21:11:48 UTC
FEDORA-2021-7639ce16f6 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.